// define a "class" that represents a Point
typedef struct Point {
   int x;
   int y;
} Point; // the name of the "class" is Point

    
// define a "class" that represents a Rectangle
typedef struct Rectangle {
   Point p1;    // attributes defined via the Point typedef
   Point p2;

   // function pointers represent "methods" of this "class"
   int (*getArea)(struct Rectangle* pr); 
   int (*getPerimeter)(struct Rectangle* pr);

} Rectangle;

// These are methods that can only be seen from within the source module (.c file) they're defined within
static int getRectangleArea(struct Rectangle* pr);
static int getRectanglePerimeter(struct Rectangle* pr);

// "constructor" method; must be public in order to be accessible outside the source module
void _Rectangle(Rectangle* pr);
